import logging
import random
import time
from telegram import Update, InlineKeyboardButton, InlineKeyboardMarkup, BotCommand
from telegram.ext import Updater, CommandHandler, MessageHandler, Filters, CallbackQueryHandler, CallbackContext
import requests
from googletrans import Translator

# تنظیمات مربوط به لاگ‌ها
logging.basicConfig(
    format='%(asctime)s - %(name)s - %(levelname)s - %(message)s',
    level=logging.INFO
)

# کلیدهای API
TELEGRAM_TOKEN = '7433975845:AAGQMF7KqrBW4iCTMZgHjnJ-91-RtRQOTig'
PIXABAY_API_KEYS = ['44163889-254f50ec39e0b9957987b93da', '44167382-a35270f8ba896d9cc0e5004e0']
PIXABAY_API_KEY = random.choice(PIXABAY_API_KEYS)
# زمان آخرین درخواست
last_request_time = {}

# تابع بررسی عضویت کاربر در کانال
def is_user_in_channel(bot, user_id):
    try:
        # شناسه کانال مورد نظر
        channel_id = "@pinterest8k"
        # درخواست اطلاعات کاربر از کانال
        member_status = bot.get_chat_member(channel_id, user_id)
        # اگر وضعیت عضویت Member یا Administrator باشد، کاربر عضو کانال است
        if member_status.status in ['member', 'administrator','creator']:
            return True
        else:
            return False
    except Exception as e:
        print(f"Error checking channel membership: {e}")
        return False
        
# تنظیمات ترجمه
translator = Translator()

# تابع جستجوی تصویر در Pixabay
def search_image(query):
    url = f"https://pixabay.com/api/?key={PIXABAY_API_KEY}&q={query}&image_type=photo"
    response = requests.get(url)
    data = response.json()
    if data['hits']:
        # انتخاب تصادفی یکی از تصاویر
        return random.choice(data['hits'])['webformatURL']
    else:
        return None

# تابع شروع ربات
def start(update: Update, context: CallbackContext):
    user_id = update.message.from_user.id
    if not is_user_in_channel(context.bot, user_id):
        update.message.reply_text("شما باید در کانال عضو شوید تا بتوانید از این سرویس استفاده کنید.")
        # ایجاد دکمه شیشه‌ای برای ارسال لینک کانال
        markup = InlineKeyboardMarkup([[InlineKeyboardButton(text="عضویت در کانال", url="https://t.me/pinterest8k")]])
        update.message.reply_text("برای عضویت در کانال، روی دکمه زیر کلیک کنید:", reply_markup=markup)
        return
    
    keyboard = [
        [InlineKeyboardButton("English", callback_data='en'), InlineKeyboardButton("فارسی", callback_data='fa')]
    ]
    reply_markup = InlineKeyboardMarkup(keyboard)
    update.message.reply_text('Choose your language/لطفا زبان خود را انتخاب کنید:', reply_markup=reply_markup)

# تابع تنظیم زبان
def button(update: Update, context: CallbackContext):
    query = update.callback_query
    user_id = query.from_user.id
    if not is_user_in_channel(context.bot, user_id):
        query.message.reply_text("شما باید در کانال عضو شوید تا بتوانید از این سرویس استفاده کنید.")
        # ایجاد دکمه شیشه‌ای برای ارسال لینک کانال
        markup = InlineKeyboardMarkup([[InlineKeyboardButton(text="عضویت در کانال", url="https://t.me/lafpersian")]])
        query.message.reply_text("برای عضویت در کانال، روی دکمه زیر کلیک کنید:", reply_markup=markup)
        return
    
    query.answer()
    context.user_data['lang'] = query.data
    if query.data == 'en':
        query.edit_message_text(text="You have selected English. Please enter a topic to search for an image.")
    elif query.data == 'fa':
        query.edit_message_text(text="شما فارسی را انتخاب کردید. لطفا یک موضوع وارد کنید تا تصویر مربوط به آن را پیدا کنم.")
# تابع پردازش پیام‌های متنی
def handle_message(update: Update, context: CallbackContext):
    user_id = update.message.from_user.id
    lang = context.user_data.get('lang', 'en')
    
    if not is_user_in_channel(context.bot, user_id):
        if lang == 'en':
            update.message.reply_text("You must join the channel to use this service.")
        else:
            update.message.reply_text("شما باید در کانال عضو شوید تا بتوانید از این سرویس استفاده کنید.")
        # ایجاد دکمه شیشه‌ای برای ارسال لینک کانال
        markup = InlineKeyboardMarkup([[InlineKeyboardButton(text="Join the channel" if lang == 'en' else "عضویت در کانال", url="https://t.me/lafpersian")]])
        update.message.reply_text("Click the button below to join the channel:" if lang == 'en' else "برای عضویت در کانال، روی دکمه زیر کلیک کنید:", reply_markup=markup)
        return

    # بررسی زمان آخرین درخواست
    current_time = time.time()
    if user_id in last_request_time:
        elapsed_time = current_time - last_request_time[user_id]
        if elapsed_time < 8:  # حداقل 20 ثانیه بین درخواست‌ها
            if lang == 'en':
                update.message.reply_text("Please wait a few seconds before making another request.")
            else:
                update.message.reply_text("لطفاً چند ثانیه صبر کنید و مجدد درخواست دهید.")
            return

    last_request_time[user_id] = current_time
    
    query = update.message.text
    
    if lang == 'fa':
        translated = translator.translate(query, src='fa', dest='en')
        query = translated.text
    
    image_url = search_image(query)
    if image_url:
        try:
            button_text = "More Image" if lang == 'en' else "تصویر دیگر"
            keyboard = [
                [InlineKeyboardButton(button_text, callback_data=f'more_{query}_{lang}')]
            ]
            reply_markup = InlineKeyboardMarkup(keyboard)
            update.message.reply_photo(photo=image_url, reply_markup=reply_markup)
        except Exception as e:
            logging.error(f"Error sending photo: {e}")
            if lang == 'en':
                update.message.reply_text('There was an error sending the image.')
            else:
                update.message.reply_text('مشکلی در ارسال تصویر پیش آمد.')
    else:
        if lang == 'en':
            update.message.reply_text('Sorry, no image found.')
        else:
            update.message.reply_text('متاسفم، تصویری پیدا نشد.')

# تابع پردازش درخواست تصویر بیشتر
def more_image(update: Update, context: CallbackContext):
    query = update.callback_query
    user_id = query.from_user.id
    lang = context.user_data.get('lang', 'en')
    
    if not is_user_in_channel(context.bot, user_id):
        if lang == 'en':
            query.message.reply_text("You must join the channel to use this service.")
        else:
            query.message.reply_text("شما باید در کانال عضو شوید تا بتوانید از این سرویس استفاده کنید.")
        # ایجاد دکمه شیشه‌ای برای ارسال لینک کانال
        markup = InlineKeyboardMarkup([[InlineKeyboardButton(text="Join the channel" if lang == 'en' else "عضویت در کانال", url="https://t.me/lafpersian")]])
        query.message.reply_text("Click the button below to join the channel:" if lang == 'en' else "برای عضویت در کانال، روی دکمه زیر کلیک کنید:", reply_markup=markup)
        return
    
    query.answer()
    search_query, lang = query.data.split('_', 2)[1:]
    
    # بررسی زمان آخرین درخواست
    current_time = time.time()
    if user_id in last_request_time:
        elapsed_time = current_time - last_request_time[user_id]
        if elapsed_time < 20:  # حداقل 20 ثانیه بین درخواست‌ها
            if lang == 'en':
                query.message.reply_text("Please wait a few seconds before making another request.")
            else:
                query.message.reply_text("لطفاً چند ثانیه صبر کنید و مجدد درخواست دهید.")
            return

    last_request_time[user_id] = current_time
    
    image_url = search_image(search_query)
    if image_url:
        try:
            button_text = "More Image" if lang == 'en' else "تصویر دیگر"
            keyboard = [
                [InlineKeyboardButton(button_text, callback_data=f'more_{search_query}_{lang}')]
            ]
            reply_markup = InlineKeyboardMarkup(keyboard)
            query.message.reply_photo(photo=image_url, reply_markup=reply_markup)
        except Exception as e:
            logging.error(f"Error sending photo: {e}")
            if lang == 'en':
                query.message.reply_text('There was an error sending the image.')
            else:
                query.message.reply_text('مشکلی در ارسال تصویر پیش آمد.')
    else:
        if lang == 'en':
            query.message.reply_text('Sorry, no image found.')
        else:
            query.message.reply_text('متاسفم، تصویری پیدا نشد.')

# هندلر خطاها
def error(update: Update, context: CallbackContext):
    logging.error(f"Update {update} caused error {context.error}")

# تابع اصلی برای راه‌اندازی ربات
def main():
    updater = Updater(TELEGRAM_TOKEN, use_context=True)
    dispatcher = updater.dispatcher

    dispatcher.add_handler(CommandHandler("start", start))
    dispatcher.add_handler(CallbackQueryHandler(button, pattern='^(en|fa)$'))
    dispatcher.add_handler(CallbackQueryHandler(more_image, pattern='^more_'))
    dispatcher.add_handler(MessageHandler(Filters.text & ~Filters.command, handle_message))
    dispatcher.add_error_handler(error)  # اضافه کردن هندلر خطا

    # تنظیم دستورات منو
    updater.bot.set_my_commands([
        BotCommand("start", "Restart the bot / شروع مجدد ربات")
    ])

    updater.start_polling()
    updater.idle()

if __name__ == '__main__':
    main()
